## mingw-w64-itk-5.4.4-1.src.tar.zst

=== Modules/IO/TransformFactory/CMakeLists.txt ===
project(ITKTransformFactory)
set(ITKTransformFactory_LIBRARIES ITKTransformFactory)

set(ITK_TRANSFORM_FACTORY_MAX_DIM
    4
    CACHE STRING "The transform dimensions in the range [2-(this number)] supported by the TransformIO.")
mark_as_advanced(ITK_TRANSFORM_FACTORY_MAX_DIM)
if(ITK_TRANSFORM_FACTORY_MAX_DIM LESS "3")
  message(FATAL_ERROR "ITK_TRANSFORM_FACTORY_MAX_DIM must be an integer greater than 2.")
endif()

itk_module_impl()

=== Modules/Core/Common/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKCommon)

set(WRAPPER_SUBMODULE_ORDER
    itkFixedArray
    itkVector
    itkCovariantVector
    itkPoint
    itkTriangleHelper
    itkVariableSizeMatrix
    itkVersor
    stdcomplex
    vnl_c_vector
    vnl_cost_function
    vnl_diag_matrix
    vnl_file_matrix
    vnl_file_vector
    vnl_fortran_copy
    vnl_least_squares_function
    vnl_matrix_fixed
    vnl_matrix_fixed_ref
    vnl_matrix_ref
    vnl_vector_ref
    vnl_matrix
    vnl_vector
    vnl_unary_function
    ITKCommonBase
    itkSize
    itkOffset
    itkArray
    itkIndex
    itkContinuousIndex
    itkMatrix
    itkVectorContainer
    itkMapContainer
    itkBoundingBox
    itkRGBPixel
    itkRGBAPixel
    itkVariableLengthVector
    itkImageRegion
    itkSymmetricSecondRankTensor
    itkImage
    itkVectorImage
    itkSpecialCoordinatesImage
    itkPhasedArray3DSpecialCoordinatesImage
    itkNeighborhood
    #  SwigExtras
    itkImageSourceCommon
    itkImageSource
    itkImageToImageFilterCommon
    itkImageToImageFilterA
    itkImageToImageFilterB
    itkInPlaceImageFilterA
    itkInPlaceImageFilterB
    itkDefaultDynamicMeshTraits
    itkDefaultStaticMeshTraits
    itkFunctionBase
    #  itkCellInterface
    #  itkPointSet
    #  itkVertexCell
    #  itkLineCell
)

itk_auto_load_and_end_wrap_submodules()

=== Modules/Filtering/DisplacementField/test/CMakeLists.txt ===
itk_module_test()
set(ITKDisplacementFieldTests
    itkComposeDisplacementFieldsImageFilterTest.cxx
    itkDisplacementFieldJacobianDeterminantFilterTest.cxx
    itkIterativeInverseDisplacementFieldImageFilterTest.cxx
    itkLandmarkDisplacementFieldSourceTest.cxx
    itkInverseDisplacementFieldImageFilterTest.cxx
    itkInvertDisplacementFieldImageFilterTest.cxx
    itkDisplacementFieldToBSplineImageFilterTest.cxx
    itkDisplacementFieldTransformTest.cxx
    itkGaussianSmoothingOnUpdateDisplacementFieldTransformTest.cxx
    itkBSplineSmoothingOnUpdateDisplacementFieldTransformTest.cxx
    itkGaussianExponentialDiffeomorphicTransformTest.cxx
    itkBSplineExponentialDiffeomorphicTransformTest.cxx
    itkTimeVaryingVelocityFieldTransformTest.cxx
    itkTimeVaryingVelocityFieldIntegrationImageFilterTest.cxx
    itkTimeVaryingBSplineVelocityFieldTransformTest.cxx
    itkTransformToDisplacementFieldFilterTest.cxx
    itkTransformToDisplacementFieldFilterTest1.cxx
    itkDisplacementFieldTransformCloneTest.cxx
    itkExponentialDisplacementFieldImageFilterTest.cxx)

createtestdriver(ITKDisplacementField "${ITKDisplacementField-Test_LIBRARIES}" "${ITKDisplacementFieldTests}")

itk_add_test(
  NAME
  itkComposeDisplacementFieldsImageFilterTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkComposeDisplacementFieldsImageFilterTest)
itk_add_test(
  NAME
  itkDisplacementFieldJacobianDeterminantFilterTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkDisplacementFieldJacobianDeterminantFilterTest)
itk_add_test(
  NAME
  itkIterativeInverseDisplacementFieldImageFilterTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkIterativeInverseDisplacementFieldImageFilterTest
  ${ITK_TEST_OUTPUT_DIR}/itkIterativeInverseDisplacementFieldImageFilterTest.mha
  5
  0)
itk_add_test(
  NAME
  itkLandmarkDisplacementFieldSourceTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkLandmarkDisplacementFieldSourceTest
  ${ITK_TEST_OUTPUT_DIR}/itkLandmarkDisplacementFieldSourceTestLandmarks.txt
  ${ITK_TEST_OUTPUT_DIR}/itkLandmarkDisplacementFieldSourceTest.mha)
itk_add_test(
  NAME
  itkInverseDisplacementFieldImageFilterTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkInverseDisplacementFieldImageFilterTest
  ${ITK_TEST_OUTPUT_DIR}/itkInverseDisplacementFieldImageFilterTest.mha)
itk_add_test(
  NAME
  itkDisplacementFieldTransformTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkDisplacementFieldTransformTest
  1e-6
  1e-6)
itk_add_test(
  NAME
  itkGaussianSmoothingOnUpdateDisplacementFieldTransformTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkGaussianSmoothingOnUpdateDisplacementFieldTransformTest)
itk_add_test(
  NAME
  itkBSplineSmoothingOnUpdateDisplacementFieldTransformTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkBSplineSmoothingOnUpdateDisplacementFieldTransformTest)
itk_add_test(
  NAME
  itkGaussianExponentialDiffeomorphicTransformTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkGaussianExponentialDiffeomorphicTransformTest)
itk_add_test(
  NAME
  itkBSplineExponentialDiffeomorphicTransformTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkBSplineExponentialDiffeomorphicTransformTest)
itk_add_test(
  NAME
  itkTimeVaryingVelocityFieldTransformTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkTimeVaryingVelocityFieldTransformTest)
itk_add_test(
  NAME
  itkTimeVaryingVelocityFieldIntegrationImageFilterTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkTimeVaryingVelocityFieldIntegrationImageFilterTest
  0.3
  0.75
  100
  0.2
  0.8
  50
  1.0
  0.0
  100)
itk_add_test(
  NAME
  itkTimeVaryingBSplineVelocityFieldTransformTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkTimeVaryingBSplineVelocityFieldTransformTest)
itk_add_test(
  NAME
  itkInvertDisplacementFieldImageFilterTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkInvertDisplacementFieldImageFilterTest
  50
  0.1
  0.001
  0)
itk_add_test(
  NAME
  itkDisplacementFieldToBSplineImageFilterTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkDisplacementFieldToBSplineImageFilterTest)
itk_add_test(
  NAME
  itkTransformToDisplacementFieldFilterTest01
  COMMAND
  ITKDisplacementFieldTestDriver
  --compare
  ${ITK_TEST_OUTPUT_DIR}/itkTransformToDisplacementFieldFilterTestField01.mha
  DATA{Baseline/itkTransformToDisplacementFieldFilterTestField01.mha}
  itkTransformToDisplacementFieldFilterTest
  Affine
  ${ITK_TEST_OUTPUT_DIR}/itkTransformToDisplacementFieldFilterTestField01.mha)
itk_add_test(
  NAME
  itkTransformToDisplacementFieldFilterTest02
  COMMAND
  ITKDisplacementFieldTestDriver
  --compare
  ${ITK_TEST_OUTPUT_DIR}/itkTransformToDisplacementFieldFilterTestField02.mha
  DATA{Baseline/itkTransformToDisplacementFieldFilterTestField02.mha}
  itkTransformToDisplacementFieldFilterTest
  BSpline
  ${ITK_TEST_OUTPUT_DIR}/itkTransformToDisplacementFieldFilterTestField02.mha
  DATA{${ITK_DATA_ROOT}/Input/parametersBSpline.txt})
itk_add_test(
  NAME
  itkTransformToDisplacementFieldFilterTest03
  COMMAND
  ITKDisplacementFieldTestDriver
  --compare
  ${ITK_TEST_OUTPUT_DIR}/transformedImage.nii
  ${ITK_TEST_OUTPUT_DIR}/warpedImage.nii
  --compareNumberOfPixelsTolerance
  20
  itkTransformToDisplacementFieldFilterTest1
  ${ITK_TEST_OUTPUT_DIR}/transformedImage.nii
  ${ITK_TEST_OUTPUT_DIR}/warpedImage.nii
  1)
itk_add_test(
  NAME
  itkDisplacementFieldTransformCloneTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkDisplacementFieldTransformCloneTest)
itk_add_test(
  NAME
  itkExponentialDisplacementFieldImageFilterTest
  COMMAND
  ITKDisplacementFieldTestDriver
  itkExponentialDisplacementFieldImageFilterTest)

=== Modules/Filtering/ImageFilterBase/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKImageFilterBase)
itk_auto_load_and_end_wrap_submodules()

=== Modules/IO/GIPL/test/CMakeLists.txt ===
itk_module_test()
set(ITKIOGIPLTests itkGiplImageIOTest.cxx)

createtestdriver(ITKIOGIPL "${ITKIOGIPL-Test_LIBRARIES}" "${ITKIOGIPLTests}")

itk_add_test(
  NAME
  itkGiplImageIOTest
  COMMAND
  ITKIOGIPLTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/ramp.mhd,ramp.raw}
  ${ITK_TEST_OUTPUT_DIR}/ramp.mhd
  itkGiplImageIOTest
  DATA{${ITK_DATA_ROOT}/Input/ramp.gipl}
  ${ITK_TEST_OUTPUT_DIR}/ramp.mhd)
itk_add_test(
  NAME
  itkGiplImageIOGzTest
  COMMAND
  ITKIOGIPLTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/ramp.mhd,ramp.raw}
  ${ITK_TEST_OUTPUT_DIR}/ramp-gz.mhd
  itkGiplImageIOTest
  DATA{${ITK_DATA_ROOT}/Input/ramp.gipl.gz}
  ${ITK_TEST_OUTPUT_DIR}/ramp-gz.mhd)
itk_add_test(
  NAME
  itkGiplImageIOTest2
  COMMAND
  ITKIOGIPLTestDriver
  itkGiplImageIOTest
  DATA{${ITK_DATA_ROOT}/Input/ramp.gipl}
  ${ITK_TEST_OUTPUT_DIR}/ramp.gipl)

=== Modules/IO/JPEG/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKIOJPEG)
itk_auto_load_and_end_wrap_submodules()

=== Modules/IO/JPEG2000/test/CMakeLists.txt ===
itk_module_test()
set(ITKIOJPEG2000Tests
    itkJPEG2000ImageIOFactoryTest01.cxx
    itkJPEG2000ImageIORegionOfInterest.cxx
    itkJPEG2000ImageIOTest00.cxx
    itkJPEG2000ImageIOTest01.cxx
    itkJPEG2000ImageIOTest02.cxx
    itkJPEG2000ImageIOTest03.cxx
    itkJPEG2000ImageIOTest04.cxx
    itkJPEG2000ImageIOTest05.cxx
    itkJPEG2000ImageIOTest06.cxx)

createtestdriver(ITKIOJPEG2000 "${ITKIOJPEG2000-Test_LIBRARIES}" "${ITKIOJPEG2000Tests}")
itk_add_test(
  NAME
  itkJPEG2000Test00
  COMMAND
  ITKIOJPEG2000TestDriver
  itkJPEG2000ImageIORegionOfInterest
  DATA{Input/Bretagne1.j2k}
  ${ITK_TEST_OUTPUT_DIR}/Bretagne1_RegionTest01.tif
  160
  120
  320
  240)
itk_add_test(
  NAME
  itkJPEG2000Test01
  COMMAND
  ITKIOJPEG2000TestDriver
  itkJPEG2000ImageIOTest03
  DATA{Input/Bretagne1.j2k}
  ${ITK_TEST_OUTPUT_DIR}/Bretagne1_01.png)
itk_add_test(
  NAME
  itkJPEG2000Test02
  COMMAND
  ITKIOJPEG2000TestDriver
  itkJPEG2000ImageIOTest03
  DATA{Input/Cevennes2.jp2}
  ${ITK_TEST_OUTPUT_DIR}/Cevennes2_01.png)
itk_add_test(
  NAME
  itkJPEG2000Test03
  COMMAND
  ITKIOJPEG2000TestDriver
  itkJPEG2000ImageIOTest03
  ${ITK_TEST_OUTPUT_DIR}/Bretagne1_RegionTest01.tif
  ${ITK_TEST_OUTPUT_DIR}/Bretagne1_02.j2k)
set_tests_properties(
  itkJPEG2000Test03
  PROPERTIES DEPENDS
             itkJPEG2000Test00
             REQUIRED_FILES
             ${ITK_TEST_OUTPUT_DIR}/Bretagne1_RegionTest01.tif)

itk_add_test(
  NAME
  itkJPEG2000Test05
  COMMAND
  ITKIOJPEG2000TestDriver
  itkJPEG2000ImageIOTest05
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}
  jp2)
itk_add_test(
  NAME
  itkJPEG2000Test06
  COMMAND
  ITKIOJPEG2000TestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/cthead1-unitspacing.tif}
  ${ITK_TEST_OUTPUT_DIR}/itkJPEG2000Test06_cthead1.tif
  itkJPEG2000ImageIOTest06
  DATA{Input/cthead1.j2k}
  ${ITK_TEST_OUTPUT_DIR}/itkJPEG2000Test06_cthead1.tif)

=== Modules/IO/NRRD/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKIONRRD)
itk_auto_load_and_end_wrap_submodules()

=== Modules/IO/Stimulate/src/CMakeLists.txt ===
set(ITKIOStimulate_SRCS itkStimulateImageIO.cxx itkStimulateImageIOFactory.cxx)

itk_module_add_library(ITKIOStimulate ${ITKIOStimulate_SRCS})

=== Modules/Numerics/Statistics/test/CMakeLists.txt ===
itk_module_test()
set(ITKStatisticsTests
    itkDecisionRuleTest.cxx
    itkDenseFrequencyContainer2Test.cxx
    itkExpectationMaximizationMixtureModelEstimatorTest.cxx
    itkGaussianDistributionTest.cxx
    itkGaussianMembershipFunctionTest.cxx
    itkGaussianMixtureModelComponentTest.cxx
    itkGaussianRandomSpatialNeighborSubsamplerTest.cxx
    itkKalmanLinearEstimatorTest.cxx
    itkKdTreeBasedKmeansEstimatorTest.cxx
    itkKdTreeGeneratorTest.cxx
    itkKdTreeTest1.cxx
    itkKdTreeTest2.cxx
    itkKdTreeTest3.cxx
    itkKdTreeTestSamplePoints.cxx
    itkMaximumDecisionRuleTest.cxx
    itkMinimumDecisionRuleTest.cxx
    itkMaximumRatioDecisionRuleTest.cxx
    itkMeanSampleFilterTest.cxx
    itkMeanSampleFilterTest2.cxx
    itkMeanSampleFilterTest3.cxx
    itkHistogramTest.cxx
    itkHistogramToTextureFeaturesFilterTest.cxx
    itkHistogramToTextureFeaturesFilterNaNTest.cxx
    itkChiSquareDistributionTest.cxx
    itkCovarianceSampleFilterTest.cxx
    itkCovarianceSampleFilterTest2.cxx
    itkCovarianceSampleFilterTest3.cxx
    itkWeightedCovarianceSampleFilterTest.cxx
    itkWeightedCovarianceSampleFilterTest2.cxx
    itkWeightedMeanSampleFilterTest.cxx
    itkWeightedCentroidKdTreeGeneratorTest1.cxx
    itkWeightedCentroidKdTreeGeneratorTest8.cxx
    itkWeightedCentroidKdTreeGeneratorTest9.cxx
    itkMahalanobisDistanceMetricTest.cxx
    itkManhattanDistanceMetricTest.cxx
    itkMembershipFunctionBaseTest.cxx
    itkMembershipFunctionBaseTest2.cxx
    itkMembershipSampleTest1.cxx
    itkMembershipSampleTest2.cxx
    itkMembershipSampleTest3.cxx
    itkMembershipSampleTest4.cxx
    itkMeasurementVectorTraitsTest.cxx
    itkNeighborhoodSamplerTest1.cxx
    itkMixtureModelComponentBaseTest.cxx
    itkNormalVariateGeneratorTest1.cxx
    itkDistanceMetricTest.cxx
    itkDistanceMetricTest2.cxx
    itkDistanceToCentroidMembershipFunctionTest.cxx
    itkEuclideanDistanceMetricTest.cxx
    itkEuclideanSquareDistanceMetricTest.cxx
    itkListSampleTest.cxx
    itkImageToListSampleAdaptorTest.cxx
    itkImageToListSampleAdaptorTest2.cxx
    itkImageToListSampleFilterTest.cxx
    itkImageToListSampleFilterTest2.cxx
    itkImageToListSampleFilterTest3.cxx
    itkListSampleTest.cxx
    itkJointDomainImageToListSampleAdaptorTest.cxx
    itkPointSetToListSampleAdaptorTest.cxx
    itkProbabilityDistributionTest.cxx
    itkRandomVariateGeneratorBaseTest.cxx
    itkSampleTest.cxx
    itkSampleTest2.cxx
    itkSampleTest3.cxx
    itkSampleTest4.cxx
    itkSampleToHistogramFilterTest.cxx
    itkSampleToHistogramFilterTest2.cxx
    itkSampleToHistogramFilterTest3.cxx
    itkSampleToHistogramFilterTest4.cxx
    itkSampleToHistogramFilterTest5.cxx
    itkSampleToHistogramFilterTest6.cxx
    itkSampleToHistogramFilterTest7.cxx
    itkSampleToSubsampleFilterTest1.cxx
    itkScalarImageToCooccurrenceListSampleFilterTest.cxx
    itkScalarImageToCooccurrenceMatrixFilterTest.cxx
    itkScalarImageToCooccurrenceMatrixFilterTest2.cxx
    itkScalarImageToTextureFeaturesFilterTest.cxx
    itkScalarImageToRunLengthMatrixFilterTest.cxx
    itkScalarImageToRunLengthFeaturesFilterTest.cxx
    itkSparseFrequencyContainer2Test.cxx
    itkSpatialNeighborSubsamplerTest.cxx
    itkStandardDeviationPerComponentSampleFilterTest.cxx
    itkStatisticsTypesTest.cxx
    itkSubsampleTest.cxx
    itkSubsampleTest2.cxx
    itkSubsampleTest3.cxx
    itkTDistributionTest.cxx
    itkStatisticsAlgorithmTest.cxx
    itkStatisticsAlgorithmTest2.cxx
    itkUniformRandomSpatialNeighborSubsamplerTest.cxx
    itkVectorContainerToListSampleAdaptorTest.cxx
    itkImageToHistogramFilterTest.cxx
    itkImageToHistogramFilterTest2.cxx
    itkScalarImageToHistogramGeneratorTest.cxx)

createtestdriver(ITKStatistics "${ITKStatistics-Test_LIBRARIES}" "${ITKStatisticsTests}")

set(TEMP ${ITK_TEST_OUTPUT_DIR})

itk_add_test(
  NAME
  itkDecisionRuleTest
  COMMAND
  ITKStatisticsTestDriver
  itkDecisionRuleTest)
itk_add_test(
  NAME
  itkDenseFrequencyContainer2Test
  COMMAND
  ITKStatisticsTestDriver
  itkDenseFrequencyContainer2Test)
itk_add_test(
  NAME
  itkExpectationMaximizationMixtureModelEstimatorTest
  COMMAND
  ITKStatisticsTestDriver
  itkExpectationMaximizationMixtureModelEstimatorTest
  DATA{${ITK_DATA_ROOT}/Input/Statistics/TwoDimensionTwoGaussian.dat})
itk_add_test(
  NAME
  itkGaussianDistributionTest
  COMMAND
  ITKStatisticsTestDriver
  itkGaussianDistributionTest)
itk_add_test(
  NAME
  itkGaussianMembershipFunctionTest
  COMMAND
  ITKStatisticsTestDriver
  itkGaussianMembershipFunctionTest)
itk_add_test(
  NAME
  itkGaussianMixtureModelComponentTest
  COMMAND
  ITKStatisticsTestDriver
  itkGaussianMixtureModelComponentTest
  DATA{${ITK_DATA_ROOT}/Input/Statistics/TwoDimensionTwoGaussian.dat})
itk_add_test(
  NAME
  itkGaussianRandomSpatialNeighborSubsamplerTest
  COMMAND
  ITKStatisticsTestDriver
  --compare
  DATA{Baseline/itkGaussianRandomSubsamplingTest.mha}
  ${ITK_TEST_OUTPUT_DIR}/itkGaussianRandomSubsamplingTest.mha
  itkGaussianRandomSpatialNeighborSubsamplerTest
  ${ITK_TEST_OUTPUT_DIR}/itkGaussianRandomSubsamplingTest.mha)
itk_add_test(
  NAME
  itkKalmanLinearEstimatorTest
  COMMAND
  ITKStatisticsTestDriver
  itkKalmanLinearEstimatorTest)
itk_add_test(
  NAME
  itkKdTreeBasedKmeansEstimatorTest
  COMMAND
  ITKStatisticsTestDriver
  itkKdTreeBasedKmeansEstimatorTest
  DATA{${ITK_DATA_ROOT}/Input/Statistics/TwoDimensionTwoGaussian.dat}
  1
  28.54746
  0.07
  0)
itk_add_test(
  NAME
  itkKdTreeGeneratorTest
  COMMAND
  ITKStatisticsTestDriver
  itkKdTreeGeneratorTest
  DATA{${ITK_DATA_ROOT}/Input/Statistics/TwoDimensionTwoGaussian.dat})

itk_add_test(
  NAME
  itkKdTreeTest1
  COMMAND
  ITKStatisticsTestDriver
  --redirectOutput
  ${TEMP}/itkKdTreeTest1.txt
  itkKdTreeTest1
  100
  100
  1
  ${ITK_TEST_OUTPUT_DIR}/itkKdTreeTest1_100.dot)
set_tests_properties(itkKdTreeTest1 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkKdTreeTest1.txt)

itk_add_test(
  NAME
  itkKdTreeTest2
  COMMAND
  ITKStatisticsTestDriver
  --redirectOutput
  ${TEMP}/itkKdTreeTest2.txt
  itkKdTreeTest2
  DATA{${ITK_DATA_ROOT}/Input/pointsForKdTree.txt}
  1
  ${ITK_TEST_OUTPUT_DIR}/itkKdTreeTest2.dot)
set_tests_properties(itkKdTreeTest2 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkKdTreeTest2.txt)

itk_add_test(
  NAME
  itkKdTreeTest3
  COMMAND
  ITKStatisticsTestDriver
  --redirectOutput
  ${TEMP}/itkKdTreeTest3.txt
  itkKdTreeTest2
  DATA{${ITK_DATA_ROOT}/Input/pointsForKdTree2.txt}
  1
  ${ITK_TEST_OUTPUT_DIR}/itkKdTreeTest3.dot)
set_tests_properties(itkKdTreeTest3 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkKdTreeTest3.txt)

itk_add_test(
  NAME
  itkKdTreeTest4
  COMMAND
  ITKStatisticsTestDriver
  --redirectOutput
  ${TEMP}/itkKdTreeTest4.txt
  itkKdTreeTest1
  1000
  1000
  1)
set_tests_properties(itkKdTreeTest4 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkKdTreeTest4.txt)

itk_add_test(
  NAME
  itkKdTreeTest5
  COMMAND
  ITKStatisticsTestDriver
  --redirectOutput
  ${TEMP}/itkKdTreeTest5.txt
  itkKdTreeTest1
  1000
  1000
  2)
set_tests_properties(itkKdTreeTest5 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkKdTreeTest5.txt)

itk_add_test(
  NAME
  itkKdTreeTest6
  COMMAND
  ITKStatisticsTestDriver
  --redirectOutput
  ${TEMP}/itkKdTreeTest6.txt
  itkKdTreeTest1
  1000
  1000
  3)
set_tests_properties(itkKdTreeTest6 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkKdTreeTest6.txt)

itk_add_test(
  NAME
  itkKdTreeTest7
  COMMAND
  ITKStatisticsTestDriver
  --redirectOutput
  ${TEMP}/itkKdTreeTest7.txt
  itkKdTreeTest1
  1000
  1000
  5)
set_tests_properties(itkKdTreeTest7 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkKdTreeTest7.txt)

itk_add_test(
  NAME
  itkKdTreeTest8
  COMMAND
  ITKStatisticsTestDriver
  --redirectOutput
  ${TEMP}/itkKdTreeTest8.txt
  itkKdTreeTest1
  1000
  1000
  10)
set_tests_properties(itkKdTreeTest8 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkKdTreeTest8.txt)

itk_add_test(
  NAME
  itkKdTreeTest9
  COMMAND
  ITKStatisticsTestDriver
  --redirectOutput
  ${TEMP}/itkKdTreeTest9.txt
  itkKdTreeTest1
  1000
  1000
  20)
set_tests_properties(itkKdTreeTest9 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkKdTreeTest9.txt)

itk_add_test(
  NAME
  itkKdTreeTest10
  COMMAND
  ITKStatisticsTestDriver
  --redirectOutput
  ${TEMP}/itkKdTreeTest10.txt
  itkKdTreeTest1
  1000
  1000
  100)
set_tests_properties(itkKdTreeTest10 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkKdTreeTest10.txt)

itk_add_test(
  NAME
  itkKdTreeTest11
  COMMAND
  ITKStatisticsTestDriver
  --redirectOutput
  ${TEMP}/itkKdTreeTest11.txt
  itkKdTreeTest3
  1000
  100
  20
  16)
set_tests_properties(itkKdTreeTest11 PROPERTIES ATTACHED_FILES_ON_FAIL ${TEMP}/itkKdTreeTest11.txt)

#
#  The following tests generate graphical plots of the KdTree organization.
#  They are very helpful for debugging and verification purposes, but not so
#  much for regression testing. They need the "dot" tool that is part of the
#  Graphviz package. The dot executable is found as part of the process of
#  configuring the Doxygen documentation. Therefore, to enable these tests
#  below, you must enable BUILD_DOXYGEN and ITK_BUILD_DOCUMENTATION.
#
if(DOXYGEN_DOT_EXECUTABLE)
  itk_add_test(
    NAME
    itkKdTreeTest1Plot
    COMMAND
    ${DOXYGEN_DOT_EXECUTABLE}
    -Tpng
    -o
    ${ITK_TEST_OUTPUT_DIR}/itkKdTreeTest1_100.png
    ${ITK_TEST_OUTPUT_DIR}/itkKdTreeTest1_100.dot)
  set_tests_properties(itkKdTreeTest1Plot PROPERTIES DEPENDS itkKdTreeTest1)
  itk_add_test(
    NAME
    itkKdTreeTest2Plot
    COMMAND
    ${DOXYGEN_DOT_EXECUTABLE}
    -Tpng
    -o
    ${ITK_TEST_OUTPUT_DIR}/itkKdTreeTest2.png
    ${ITK_TEST_OUTPUT_DIR}/itkKdTreeTest2.dot)
  set_tests_properties(itkKdTreeTest2Plot PROPERTIES DEPENDS itkKdTreeTest2)
  itk_add_test(
    NAME
    itkKdTreeTest3Plot
    COMMAND
    ${DOXYGEN_DOT_EXECUTABLE}
    -Tpng
    -o
    ${ITK_TEST_OUTPUT_DIR}/itkKdTreeTest3.png
    ${ITK_TEST_OUTPUT_DIR}/itkKdTreeTest3.dot)
  set_tests_properties(itkKdTreeTest3Plot PROPERTIES DEPENDS itkKdTreeTest3)
endif()

itk_add_test(
  NAME
  itkKdTreeTestSamplePoints
  COMMAND
  ITKStatisticsTestDriver
  itkKdTreeTestSamplePoints)
itk_add_test(
  NAME
  itkMaximumDecisionRuleTest
  COMMAND
  ITKStatisticsTestDriver
  itkMaximumDecisionRuleTest)
itk_add_test(
  NAME
  itkMinimumDecisionRuleTest
  COMMAND
  ITKStatisticsTestDriver
  itkMinimumDecisionRuleTest)
itk_add_test(
  NAME
  itkMaximumRatioDecisionRuleTest
  COMMAND
  ITKStatisticsTestDriver
  itkMaximumRatioDecisionRuleTest)
itk_add_test(
  NAME
  itkMeanSampleFilterTest
  COMMAND
  ITKStatisticsTestDriver
  itkMeanSampleFilterTest)
itk_add_test(
  NAME
  itkMeanSampleFilterTest2
  COMMAND
  ITKStatisticsTestDriver
  itkMeanSampleFilterTest2)
itk_add_test(
  NAME
  itkMeanSampleFilterTest3
  COMMAND
  ITKStatisticsTestDriver
  itkMeanSampleFilterTest3)
itk_add_test(
  NAME
  itkHistogramTest
  COMMAND
  ITKStatisticsTestDriver
  itkHistogramTest)
itk_add_test(
  NAME
  itkHistogramToTextureFeaturesFilterTest
  COMMAND
  ITKStatisticsTestDriver
  itkHistogramToTextureFeaturesFilterTest)
itk_add_test(
  NAME
  itkHistogramToTextureFeaturesFilterNaNTest
  COMMAND
  ITKStatisticsTestDriver
  itkHistogramToTextureFeaturesFilterNaNTest)
itk_add_test(
  NAME
  itkChiSquareDistributionTest
  COMMAND
  ITKStatisticsTestDriver
  itkChiSquareDistributionTest)
itk_add_test(
  NAME
  itkCovarianceSampleFilterTest
  COMMAND
  ITKStatisticsTestDriver
  itkCovarianceSampleFilterTest)
itk_add_test(
  NAME
  itkCovarianceSampleFilterTest2
  COMMAND
  ITKStatisticsTestDriver
  itkCovarianceSampleFilterTest2)
itk_add_test(
  NAME
  itkCovarianceSampleFilterTest3
  COMMAND
  ITKStatisticsTestDriver
  itkCovarianceSampleFilterTest3)
itk_add_test(
  NAME
  itkWeightedCentroidKdTreeGeneratorTest1
  COMMAND
  ITKStatisticsTestDriver
  itkWeightedCentroidKdTreeGeneratorTest1
  1000
  1000
  1)
itk_add_test(
  NAME
  itkWeightedCentroidKdTreeGeneratorTest2
  COMMAND
  ITKStatisticsTestDriver
  itkWeightedCentroidKdTreeGeneratorTest1
  1000
  1000
  2)

=== Modules/Registration/GPUPDEDeformable/test/CMakeLists.txt ===
if(ITK_USE_GPU)

  itk_module_test()

  set(ITKGPUPDEDeformableRegistration-tests itkGPUDemonsRegistrationFilterTest.cxx
                                            itkGPUDemonsRegistrationFilterTest2.cxx)

  set(ITKGPUPDEDeformableRegistrationTest_LIBRARIES
      ITKCommon;ITKGPUCommon;ITKGPUFiniteDifference;ITKGPUPDEDeformableRegistration;ITKStatistics;ITKSpatialObjects;ITKPath;ITKOptimizers;ITKIOBMP;ITKIOBioRad;ITKIOGDCM;ITKIOGIPL;ITKIOJPEG;ITKIOLSM;ITKIOMeta;ITKIONIFTI;ITKIONRRD;ITKIOPNG;ITKIOStimulate;ITKIOTIFF;ITKIOVTK;itksys
  )

  createtestdriver(ITKGPUPDEDeformableRegistration "${ITKGPUPDEDeformableRegistrationTest_LIBRARIES}"
                   "${ITKGPUPDEDeformableRegistration-tests}")

  itk_add_test(
    NAME
    itkGPUDemonsRegistrationFilterTestDim2
    COMMAND
    ITKGPUPDEDeformableRegistrationTestDriver
    itkGPUDemonsRegistrationFilterTest
    2 # number of dimensions
    50 # number of iterations
    DATA{Input/LenaFix.png}
    DATA{Input/LenaMov.png}
    ${ITK_TEST_OUTPUT_DIR}/gpuDemonsRegistrationTest2D.mha)

  itk_add_test(
    NAME
    itkGPUDemonsRegistrationFilterTestDim3
    COMMAND
    ITKGPUPDEDeformableRegistrationTestDriver
    itkGPUDemonsRegistrationFilterTest
    3 # number of dimensions
    50 # number of iterations
    DATA{Input/LenaFix.png}
    DATA{Input/LenaMov.png}
    ${ITK_TEST_OUTPUT_DIR}/gpuDemonsRegistrationTest2D.mha)

  itk_add_test(
    NAME
    itkGPUDemonsRegistrationFilterTest2
    COMMAND
    ITKGPUPDEDeformableRegistrationTestDriver
    itkGPUDemonsRegistrationFilterTest2
    ${ITK_TEST_OUTPUT_DIR}/gpuDemonsRegistrationTest2Fixed.mha
    ${ITK_TEST_OUTPUT_DIR}/gpuDemonsRegistrationTest2Warped.mha)

endif()

=== Modules/Segmentation/SuperPixel/test/CMakeLists.txt ===
itk_module_test()

#${itk-module} will be the name of this module and will not need to be
#changed when this module is renamed.

set(${itk-module}Tests itkSLICImageFilterTest.cxx)

createtestdriver(${itk-module} "${${itk-module}-Test_LIBRARIES}" "${${itk-module}Tests}")

itk_add_test(
  NAME
  itkSLICImageFilterTest1
  COMMAND
  ${itk-module}TestDriver
  --compare
  "DATA{Data/Baseline/itkSLICImageFilterTest1.png,:}"
  "${ITK_TEST_OUTPUT_DIR}/itkSLICImageFilterTestOutput1.png"
  itkSLICImageFilterTest
  "DATA{Data/Input/VM1111Shrink-RGB.png}"
  "${ITK_TEST_OUTPUT_DIR}/itkSLICImageFilterTestOutput1.png"
  25
  0)

itk_add_test(
  NAME
  itkSLICImageFilterTest2
  COMMAND
  ${itk-module}TestDriver
  --compare
  "DATA{Data/Baseline/itkSLICImageFilterTest2.png}"
  "${ITK_TEST_OUTPUT_DIR}/itkSLICImageFilterTestOutput2.png"
  itkSLICImageFilterTest
  "DATA{Data/Input/VM1111Shrink-LAB.mha}"
  "${ITK_TEST_OUTPUT_DIR}/itkSLICImageFilterTestOutput2.png"
  25
  0)

itk_add_test(
  NAME
  itkSLICImageFilterTest3
  COMMAND
  ${itk-module}TestDriver
  --compare
  "DATA{Data/Baseline/itkSLICImageFilterTest3.png}"
  "${ITK_TEST_OUTPUT_DIR}/itkSLICImageFilterTestOutput3.png"
  itkSLICImageFilterTest
  "DATA{Data/Input/VM1111Shrink-LAB.mha}"
  "${ITK_TEST_OUTPUT_DIR}/itkSLICImageFilterTestOutput3.png"
  25
  1)

set(${itk-module}GTests itkSLICImageFilterGTest.cxx)

creategoogletestdriver(${itk-module} "${${itk-module}-Test_LIBRARIES}" "${${itk-module}GTests}")

=== PKGBUILD ===
# Maintainer: Sergey Popov <popov.sa@gmail.com>

_realname=itk
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=5.4.4
pkgrel=1
pkgdesc='An open-source C++ toolkit for medical image processing (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.itk.org/'
msys2_repository_url="https://github.com/InsightSoftwareConsortium/ITK"
msys2_references=(
  'aur: itk'
)
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-dcmtk"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-gdcm"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         #"${MINGW_PACKAGE_PREFIX}-opencl-icd"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-gtest"
             "${MINGW_PACKAGE_PREFIX}-opencv"
             "${MINGW_PACKAGE_PREFIX}-vtk"
             "${MINGW_PACKAGE_PREFIX}-adios2"
             $([[ ${MSYSTEM} == MINGW64 ]] || echo "${MINGW_PACKAGE_PREFIX}-anari-sdk")
             "${MINGW_PACKAGE_PREFIX}-cgns"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-gdal"
             "${MINGW_PACKAGE_PREFIX}-gl2ps"
             "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
             "${MINGW_PACKAGE_PREFIX}-liblas"
             "${MINGW_PACKAGE_PREFIX}-libogg"
             "${MINGW_PACKAGE_PREFIX}-libtheora"
             "${MINGW_PACKAGE_PREFIX}-opencascade"
             "${MINGW_PACKAGE_PREFIX}-openslide"
             "${MINGW_PACKAGE_PREFIX}-openturns"
             "${MINGW_PACKAGE_PREFIX}-openvdb"
             "${MINGW_PACKAGE_PREFIX}-openvr"
             "${MINGW_PACKAGE_PREFIX}-pdal"
             "${MINGW_PACKAGE_PREFIX}-proj"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-unixodbc"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp")
optdepends=("${MINGW_PACKAGE_PREFIX}-opencv: ITK-OpenCV bridge"
            "${MINGW_PACKAGE_PREFIX}-vtk: ITK-VTK bridge")
source=("https://github.com/InsightSoftwareConsortium/ITK/archive/v${pkgver}/ITK-${pkgver}.tar.gz"
        libminc-pr-129.patch)
sha256sums=('683027617442391220eb79869d71652a54c4b47517ca6ca14d4b01c2583f5a1c'
            '14c1fe4b41fa77aed8483dbece655740dd485e8d78184c9351063a5fb77fa0b4')

prepare() {
  cd "ITK-${pkgver}"
  patch -p1 -i "${srcdir}"/libminc-pr-129.patch
}

build() {
  local -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CARCH} == x86_64 ]]; then
    _extra_config+=("-DVNL_CONFIG_ENABLE_SSE2_ROUNDING=ON")
  else
    _extra_config+=("-DVNL_CONFIG_ENABLE_SSE2_ROUNDING=OFF")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  cmake \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DBUILD_SHARED_LIBS=ON \
    -DBUILD_DOCUMENTATION=OFF \
    -DBUILD_EXAMPLES=OFF \
    -DBUILD_TESTING=OFF \
    -DITK_INSTALL_INCLUDE_DIR=include/ITK \
    -DITK_INSTALL_DATA_DIR=share/ITK \
    -DITK_INSTALL_DOC_DIR=share/doc/ITK \
    -DITK_INSTALL_PACKAGE_DIR=lib/cmake/ITK \
    -DITK_CUSTOM_LIBRARY_SUFFIX="" \
    -DITK_LEGACY_REMOVE=ON \
    -DITK_FUTURE_LEGACY_REMOVE=ON \
    -DITK_BUILD_DEFAULT_MODULES=OFF \
    -DITKGroup_Core=ON \
    -DITKGroup_IO=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "ON" || echo "OFF") \
    -DITKGroup_Filtering=ON \
    -DITKGroup_Registration=ON \
    -DITKGroup_Segmentation=ON \
    -DITKGroup_Numerics=ON \
    -DITKGroup_Video=ON \
    -DITKGroup_ThirdParty=ON \
    -DITKGroup_Bridge=ON \
    -DITKGroup_Nonunit=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "ON" || echo "OFF") \ \
    -DITKGroup_Compatibility=ON \
    -DModule_ITKVideoBridgeOpenCV=ON \
    -DModule_ITKVtkGlue=ON \
    -DITK_USE_GPU=OFF \
    -DUSE_FFTWD=ON \
    -DUSE_FFTWF=ON \
    -DITK_USE_SYSTEM_LIBRARIES=ON \
    -DITK_USE_SYSTEM_DCMTK=ON \
    -DITK_USE_SYSTEM_DOUBLECONVERSION=ON \
    -DITK_USE_SYSTEM_EIGEN=ON \
    -DITK_USE_SYSTEM_EXPAT=ON \
    -DITK_USE_SYSTEM_FFTW=ON \
    -DITK_USE_SYSTEM_GDCM=ON \
    -DITK_USE_SYSTEM_GOOGLETEST=ON \
    -DITK_USE_SYSTEM_HDF5=ON \
    -DITK_USE_SYSTEM_JPEG=ON \
    -DITK_USE_SYSTEM_MINC=OFF \
    -DITK_USE_SYSTEM_PNG=ON \
    -DITK_USE_SYSTEM_TIFF=ON \
    -DITK_USE_SYSTEM_VXL=OFF \
    -DITK_USE_SYSTEM_ZLIB=ON \
    -DITK_SKIP_PATH_LENGTH_CHECKS=1 \
    -DITK_FORBID_DOWNLOADS=ON \
    -DVNL_CONFIG_THREAD_SAFE=ON \
    -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    "${_extra_config[@]}" \
    -S "ITK-${pkgver}" \
    -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})
  sed -s "s|${PREFIX_DEPS}|\${_IMPORT_PREFIX}|g" \
    -i "${pkgdir}${MINGW_PREFIX}/lib/cmake/${_realname}/ITKTargets-release.cmake"
  find "${pkgdir}${MINGW_PREFIX}/lib/cmake/${_realname}" -name '*.cmake' -exec \
    sed -s "s|${PREFIX_DEPS}|\${ITK_INSTALL_PREFIX}|g" -i {} \;

  install -Dm644 "ITK-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
  install -Dm644 "ITK-${pkgver}/NOTICE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/NOTICE"
  install -Dm644 "ITK-${pkgver}/Modules/ThirdParty/KWSys/src/KWSys/Copyright.txt" \
    "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/KWSys/Copyright.txt"
}
